/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.datei.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class DateiUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final java.util.Date erstellungszeitpunkt;

    public java.util.Date getErstellungszeitpunkt(){
      return erstellungszeitpunkt;
    }
    protected final java.lang.String originalDateiname;

    public java.lang.String getOriginalDateiname(){
      return originalDateiname;
    }

  protected final de.ivu.elect.business.mandant.entity.MandantUK mandantUK;

    public de.ivu.elect.business.mandant.entity.MandantUK getMandantUK(){
      return mandantUK;
    }

  public DateiUK(
java.util.Date erstellungszeitpunkt
, java.lang.String originalDateiname
,   de.ivu.elect.business.mandant.entity.MandantUK mandantUK
  ) {
    super();


      this.erstellungszeitpunkt = erstellungszeitpunkt;
      this.originalDateiname = originalDateiname;
        this.mandantUK = mandantUK;
    }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((erstellungszeitpunkt == null) ? 0 : erstellungszeitpunkt.hashCode());
                    result = result + ((originalDateiname == null) ? 0 : originalDateiname.hashCode());
        
                    result = result + ((mandantUK == null) ? 0 : mandantUK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            DateiUK other = (DateiUK) obj;

                if (erstellungszeitpunkt == null) {
          if (other.erstellungszeitpunkt != null) {
            return false;
          }
        } else if (!erstellungszeitpunkt.equals(other.erstellungszeitpunkt)) {
          return false;
        }
                if (originalDateiname == null) {
          if (other.originalDateiname != null) {
            return false;
          }
        } else if (!originalDateiname.equals(other.originalDateiname)) {
          return false;
        }
        
                if (mandantUK == null) {
          if (other.mandantUK != null) {
            return false;
          }
        } else if (!mandantUK.equals(other.mandantUK)) {
          return false;
        }
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return DateiConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(mandantUK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(DateiConstants.MESSAGE_KEY_ENTITY_EINZAHL, DateiConstants.MESSAGE_KEY_ERSTELLUNGSZEITPUNKT_EINZAHL, erstellungszeitpunkt));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(DateiConstants.MESSAGE_KEY_ENTITY_EINZAHL, DateiConstants.MESSAGE_KEY_ORIGINAL_DATEINAME_EINZAHL, originalDateiname));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "DateiUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"erstellungszeitpunkt="+erstellungszeitpunkt
                            +", "                +"originalDateiname="+originalDateiname
                                        +", "                +"mandantUK="+mandantUK
                        ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(erstellungszeitpunkt);
         list.add(originalDateiname);
     return list;
   }

            public static <E extends Datei> java.util.Map<DateiUK, E> mappeDateiNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(Datei::getDateiUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<Datei, DateiUK> getDateiToUKFunction() {
                return Datei::getDateiUK;
                }

}
